<template>
  <div>
    <Multiselect
      v-model="selection"
      style="margin-top: 0.5em;"
      class="search-usergroups"
      :options="results"
      :optionsLimit="10"
      :allow-empty="false"
      track-by="id"
      label="display_name"
      :resetAfter="false"
      selectLabel=""
      selectedLabel=""
      deselectLabel=""
      :searchable="true"
      :placeholder="placeholder"
      :showNoResults="true"
      :loading="loading"
      :clearOnSelect="false"
      :preserveSearch="false"
      @search-change="search"
      @close="select"
    >
      <template slot="clear">
        <div
          v-if="selection"
          class="multiselect__clear"
          @click.prevent.stop="selection = null"
        >
          <b-icon-x font-scale="2"/>
        </div>
      </template>
      <span slot="noResult">
        Aucun résultat.
      </span>
      <span slot="noOptions">
        Saisissez les premiers caractères ...
      </span>
    </Multiselect>
  </div>
</template>

<script>
import Multiselect from 'vue-multiselect';

import { mapState, mapMutations, mapActions } from 'vuex';

export default {
  name: 'SearchOrganisations',

  components: {
    Multiselect
  },

  props: {
    usergroup: {
      type: Object,
      default: () => { return {} }
    },
    resetAfter: {
      type: Boolean,
      default: true
    },
    placeholder: {
      type: String,
      default: 'Ajouter cette organisation à des groupes d\'organisations'
    }
  },

  data() {
    return {
      selection: null,
      loading: false,
      text: null,
      results: []
    };
  },

  computed: {
    ...mapState('organisations', [
      'organisationsList'
    ])
  },

  watch: {
    text: function(newValue) {
      this.loading = true;
      this.SEARCH_ORGANISATIONS_LIST({
        text: newValue
      })
      .then(() => {
        if (newValue) {
          this.results = this.organisationsList;
        } else {
          // this.results.splice(0);
          this.results = this.organisationsList;
        }
        this.loading = false;
      });
    }
  },

  created() {
    this.RESET_CANCELLABLE_SEARCH_REQUEST();
    if (this.usergroup && this.usergroup.organisation && this.usergroup.organisation.id) {
      this.selection = this.usergroup;
    } else if (this.usergroup && this.usergroup.id) {
      this.selection = this.usergroup;
    }
    this.results = this.organisationsList;
  },

  methods: {
    ...mapMutations(['RESET_CANCELLABLE_SEARCH_REQUEST']),
    ...mapActions('organisations', [
      'SEARCH_ORGANISATIONS_LIST'
    ]),

    search(text) {
      this.text = text;
    },

    select() {
      this.$emit('select', this.selection);
    },

    clear() {
      this.selection = null;
    }
  }
}
</script>
